setup-disk.in 27.3 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2 3 4 5
#!/bin/sh

PREFIX=
. "$PREFIX/lib/libalpine.sh"

6
MBR=${MBR:-"/usr/share/syslinux/mbr.bin"}
7 8
ROOTFS=${ROOTFS:-ext4}
BOOTFS=${BOOTFS:-ext4}
9
VARFS=${VARFS:-ext4}
Natanael Copa's avatar
Natanael Copa committed
10

11 12 13
# default location for mounted root
SYSROOT=${SYSROOT:-/mnt}

14 15 16
# machine arch
ARCH=$(apk --print-arch)

Natanael Copa's avatar
Natanael Copa committed
17 18 19 20 21 22 23 24 25 26
in_list() {
	local i="$1"
	shift
	while [ $# -gt 0 ]; do
		[ "$i" = "$1" ] && return 0
		shift
	done
	return 1
}

27 28 29 30 31 32 33 34 35 36 37
all_in_list() {
	local needle="$1"
	local i
	[ -z "$needle" ] && return 1
	shift
	for i in $needle; do
		in_list "$i" $@ || return 1
	done
	return 0
}

38 39 40 41 42 43 44 45
# wrapper to only show given device
_blkid() {
	blkid | grep "^$1:"
}

# if given device have an UUID display it, otherwise return the device
uuid_or_device() {
	local i=
46 47 48
	case "$1" in
		/dev/md*) echo "$1" && return 0;;
	esac
49 50 51 52 53 54 55 56 57 58 59 60 61
	for i in $(_blkid "$1"); do
		case "$i" in
			UUID=*) eval $i;;
		esac
	done
	if [ -n "$UUID" ]; then
		echo "UUID=$UUID"
	else
		echo "$1"
	fi
}

# generate an fstab from a given mountpoint. Convert to UUID if possible
62
enumerate_fstab() {
63
	local mnt="$1"
64
	local fs_spec= fs_file= fs_vfstype= fs_mntops= fs_freq= fs_passno=
65
	[ -z "$mnt" ] && return
66 67
	local escaped_mnt=$(echo $mnt | sed -e 's:/*$::' -e 's:/:\\/:g')
	awk "\$2 ~ /^$escaped_mnt(\/|\$)/ {print \$0}" /proc/mounts | \
68
		sed "s:$mnt:/:g; s: :\t:g" | sed -E 's:/+:/:g' | \
69 70 71
		while read fs_spec fs_file fs_vfstype fs_mntops fs_freq fs_passno; do
			echo -e "$(uuid_or_device $fs_spec)\t${fs_file}\t${fs_vfstype}\t${fs_mntops} ${fs_freq} ${fs_passno}"
		done
72 73
}

74 75 76 77 78
is_vmware() {
	grep -q VMware /proc/scsi/scsi 2>/dev/null \
		|| grep -q VMware /proc/ide/hd*/model 2>/dev/null
}

79 80 81 82 83
# return true (0) if given device is lvm
is_lvm() {
	lvs "$1" >/dev/null 2>&1
}

84 85
# Find the disk device from given partition
disk_from_part() {
86 87
	# we need convert cciss/c0d0* cciss!c0d0*...
	local i= part=$(echo ${1#/dev/} | sed 's:/:!:g')
88 89
	for i in /sys/block/*/$part; do
		i=${i%/*}
90
		# ...and back from cciss!c0d0 to cciss/c0d0
91 92 93 94
		if [ -b "/dev/${i##*/}" ]; then
			echo "/dev/${i##*/}" | sed 's:!:/:g'
			return 0
		fi
95 96 97 98
	done
	return 1
}

99 100 101 102 103 104 105 106 107 108 109 110 111 112
unpack_apkovl() {
	local ovl="$1"
	local dest="$2"
	local suffix=${ovl##*.}
	local i
	ovlfiles=/tmp/ovlfiles
	if [ "$suffix" = "gz" ]; then
		if ! tar -C "$dest" --numeric-owner -zxvf "$ovl" > $ovlfiles; then
			echo -n "Continue anyway? [Y/n]: "
			read i
			case "$i" in
				n*|N*) return 1;;
			esac
		fi
113
		return 0
114 115
	fi

116
	apk add --quiet openssl
117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133

	if ! openssl list-cipher-commands | grep "^$suffix$" > /dev/null; then
		errstr="Cipher $suffix is not supported"
		return 1
	fi
	local count=0
	# beep
	echo -e "\007"
	while [ $count -lt 3 ]; do
		openssl enc -d -$suffix -in "$ovl" | tar --numeric-owner \
			-C "$dest" -zxv >$ovlfiles 2>/dev/null && return 0
		count=$(( $count + 1 ))
	done
	ovlfiles=
	return 1
}

134 135 136 137 138 139 140 141
# find filesystem of given mounted dir
find_mount_fs() {
	local mount_point="$1"
	awk "\$2 == \"$mount_point\" {print \$3}" /proc/mounts | tail -n 1
}

# find device for given mounted dir
find_mount_dev() {
142
	local mnt="$1"
143 144 145 146
	awk "\$2 == \"$mnt\" { print \$1 }" /proc/mounts | tail -n 1
}

supported_boot_fs() {
147
	local supported="ext2 ext3 ext4 btrfs xfs"
148 149 150 151 152 153 154 155
	local fs=
	for fs in $supported; do
		[ "$fs" = "$1" ] && return 0
	done
	echo "$1 is not supported. Only supported are: $supported" >&2
	return 1
}

156 157
find_volume_group() {
	local lv=${1##*/}
158
	lvs --noheadings "$1" | awk '{print $2}'
159 160 161 162 163 164 165
}

find_pvs_in_vg() {
	local vg="$1"
	pvs --noheadings | awk "\$2 == \"$vg\" {print \$1}"
}

166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190
# echo current grsecurity option and set new
set_grsec() {
	local key="$1" value="$2"
	if ! [ -e /proc/sys/kernel/grsecurity/$key ]; then
		return 0
	fi
	cat /proc/sys/kernel/grsecurity/$key
	echo $value > /proc/sys/kernel/grsecurity/$key
}

init_chroot_mounts() {
	local mnt="$1" i=
	for i in proc dev; do
		mkdir -p "$mnt"/$i
		mount --bind /$i "$mnt"/$i
	done
}

cleanup_chroot_mounts() {
	local mnt="$1" i=
	for i in proc dev; do
		umount "$mnt"/$i
	done
}

191 192 193 194 195 196 197 198 199
has_bootopt() {
	local opt="$1"
	set -- $(cat /proc/cmdline)
	for i; do
		[ "$i" = "$opt" ] && return 0
	done
	return 1
}

200 201
# setup grub bootloader
setup_grub() {
202 203
	local mnt="$1" root="$2" modules="$3" kernel_opts="$4"
	shift 4
204 205 206 207 208 209 210 211 212 213 214 215
	local disks="${@}"

	for disk in $disks; do
		# install grub
		prep=$(find_prep_partition $disk)
		echo "Installing grub on $prep"
		grub-install --boot-directory="$mnt"/boot/ $prep
	done
	# create grub config
	cat > "$mnt"/boot/grub/grub.cfg  <<- EOF
	set timeout=2
	menuentry "Alpine Linux" {
216
		linux   /boot/vmlinuz $modules root=$root $kernel_opts
217 218 219 220 221 222 223
		initrd  /boot/initramfs-$KERNEL_FLAVOR
	}
	EOF
}

# setup syslinux bootloader
setup_syslinux() {
224 225
	local mnt="$1" root="$2" modules="$3" kernel_opts="$4" bootdev="$5"
	local exlinux_raidopt=
226 227 228 229 230 231 232 233 234

	sed -e "s:^root=.*:root=$root:" \
		-e "s:^default_kernel_opts=.*:default_kernel_opts=\"$kernel_opts\":" \
		-e "s:^modules=.*:modules=$modules:" \
		/etc/update-extlinux.conf > "$mnt"/etc/update-extlinux.conf
	if [ "$(rc --sys)" = "XEN0" ]; then
		sed -i -e "s:^default=.*:default=xen-grsec:" \
			"$mnt"/etc/update-extlinux.conf
	fi
235 236 237 238 239 240 241

	# Check if we boot from raid so we can pass proper option to
	# extlinux later.
	if [ -e "/sys/block/${bootdev#/dev/}/md" ]; then
		extlinux_raidopt="--raid"
	fi

242 243 244
	extlinux $extlinux_raidopt --install "$mnt"/boot
}

245
install_mounted_root() {
246 247 248
	local mnt="$1"
	shift 1
	local disks="${@}" mnt_boot= boot_fs= root_fs=
249
	local initfs_features="ata base ide scsi usb virtio"
250
	local pvs= dev= rootdev= bootdev= extlinux_raidopt= root= modules=
251
	local kernel_opts="quiet"
252

253
	rootdev=$(find_mount_dev "$mnt")
254 255 256 257
	if [ -z "$rootdev" ]; then
		echo "$mnt does not seem to be a mount point" >&2
		return 1
	fi
258
	root_fs=$(find_mount_fs "$mnt")
259 260 261 262
	initfs_features="$initfs_features $root_fs"

	if is_lvm "$rootdev"; then
		initfs_features="$initfs_features lvm"
263 264
		local vg=$(find_volume_group "$rootdev")
		pvs=$(find_pvs_in_vg $vg)
265 266
	fi

267

268 269 270
	bootdev=$(find_mount_dev "$mnt"/boot)
	if [ -z "$bootdev" ]; then
		bootdev=$rootdev
271
		mnt_boot="$mnt"
272 273 274 275 276 277
	else
		mnt_boot="$mnt"/boot
	fi
	boot_fs=$(find_mount_fs "$mnt_boot")
	supported_boot_fs "$boot_fs" || return 1

278
	# check if our root is on raid so we can feed mkinitfs and
279
	# bootloader conf with the proper kernel module params
280
	for dev in $rootdev $pvs; do
281 282 283 284 285 286 287 288

		# check if we need hardware raid drivers
		case $dev in
		/dev/cciss/*)
			initfs_features="${initfs_features% raid} raid"
			;;
		esac

289 290 291
		[ -e "/sys/block/${dev#/dev/}/md" ] || continue

		local md=${dev#/dev/}
292
		initfs_features="${initfs_features% raid} raid"
293 294
		local level=$(cat /sys/block/$md/md/level)
		case "$level" in
295 296
			raid1) raidmod="${raidmod%,raid1},raid1";;
			raid[456]) raidmod="${raidmod%,raid456},raid456";;
297 298
		esac
	done
299 300


301 302 303 304 305 306
	if [ -n "$VERBOSE" ]; then
		echo "Root device:     $rootdev"
		echo "Root filesystem: $root_fs"
		echo "Boot device:     $bootdev"
		echo "Boot filesystem: $boot_fs"
	fi
307

308
	if [ -z "$APKOVL" ]; then
309 310
		ovlfiles=/tmp/ovlfiles
		lbu package - | tar -C "$mnt" -zxv > "$ovlfiles"
311 312 313 314
		# comment out local repositories
		if [ -f "$mnt"/etc/apk/repositories ]; then
			sed -i -e 's:^/:#/:' "$mnt"/etc/apk/repositories
		fi
315 316
	else
		echo "Restoring backup from $APKOVL to $rootdev..."
317
		unpack_apkovl "$APKOVL" "$mnt" || return 1
318
	fi
319

320 321 322
	# we should not try start modloop on sys install
	rm -f "$mnt"/etc/runlevels/*/modloop

323
	# generate mkinitfs.conf
324
	mkdir -p "$mnt"/etc/mkinitfs/features.d
325
	echo "features=\"$initfs_features\"" > "$mnt"/etc/mkinitfs/mkinitfs.conf
326
	if [ -n "$raidmod" ]; then
327 328
		echo "/sbin/mdadm" > "$mnt"/etc/mkinitfs/features.d/raid.files
		echo "/etc/mdadm.conf" >> "$mnt"/etc/mkinitfs/features.d/raid.files
329
	fi
330

331 332
	# generate update-extlinux.conf
	root=$(uuid_or_device $rootdev)
333
	kernel_opts="$kernel_opts rootfstype=$root_fs"
334 335 336
	if is_vmware; then
		kernel_opts="pax_nouderef $kernel_opts"
	fi
337 338 339
	if has_bootopt nomodeset; then
		kernel_opts="nomodeset $kernel_opts"
	fi
340 341
	modules="sd-mod,usb-storage,${root_fs}${raidmod}"

342 343 344 345 346
	# generate the fstab
	if [ -f "$mnt"/etc/fstab ]; then
		mv "$mnt"/etc/fstab "$mnt"/etc/fstab.old
	fi
	enumerate_fstab "$mnt" >> "$mnt"/etc/fstab
347 348 349 350
	if [ -n "$SWAP_DEVICE" ]; then
		echo -e "${SWAP_DEVICE}\tswap\tswap\tdefaults\t0 0" \
			>> "$mnt"/etc/fstab
	fi
351 352 353 354 355
	cat >>"$mnt"/etc/fstab <<-__EOF__
		/dev/cdrom	/media/cdrom	iso9660	noauto,ro 0 0
		/dev/fd0	/media/floppy	vfat	noauto	0 0
		/dev/usbdisk	/media/usb	vfat	noauto	0 0
	__EOF__
356
	# remove the installed db in case its there so we force re-install
357
	rm -f "$mnt"/var/lib/apk/installed "$mnt"/lib/apk/db/installed
358
	echo "Installing system on $rootdev:"
359
	case "$ARCH" in
360 361
                ppc64le) setup_grub "$mnt" "$root" "$modules" "$kernel_opts" $disks;;
                *) setup_syslinux "$mnt" "$root" "$modules" "$kernel_opts" "$bootdev";;
362
        esac
363

364 365 366 367
	# apk reads config from target root so we need to copy the config
	mkdir -p "$mnt"/etc/apk/keys/
	cp /etc/apk/keys/* "$mnt"/etc/apk/keys/

368
	local apkflags="--initdb --quiet --progress --update-cache --clean-protected"
369 370 371
	local pkgs=$(grep -h -v -w sfdisk "$mnt"/etc/apk/world \
		"$mnt"/var/lib/apk/world 2>/dev/null)

372
	pkgs="$pkgs acct linux-$KERNEL_FLAVOR alpine-base"
373 374 375
	if [ "$(rc --sys)" = "XEN0" ]; then
		pkgs="$pkgs xen-hypervisor"
	fi
376 377 378 379 380
	local repos=$(sed -e 's/\#.*//' /etc/apk/repositories)
	local repoflags=
	for i in $repos; do
		repoflags="$repoflags --repository $i"
	done
381

382 383
	chroot_caps=$(set_grsec chroot_caps 0)
	init_chroot_mounts "$mnt"
384
	apk add --root "$mnt" $apkflags --overlay-from-stdin \
Natanael Copa's avatar
Natanael Copa committed
385
		$repoflags $pkgs <$ovlfiles
386 387 388 389
	local ret=$?
	cleanup_chroot_mounts "$mnt"
	set_grsec chroot_caps $chroot_caps > /dev/null
	return $ret
390 391 392 393
}

unmount_partitions() {
	local mnt="$1"
394 395

	# unmount the partitions
396
	umount $(awk '{print $2}' /proc/mounts | egrep "^$mnt(/|\$)" | sort -r)
397
}
398

399 400 401
# figure out decent default swap size in mega bytes
find_swap_size() {
	local memtotal_kb=$(awk '$1 == "MemTotal:" {print $2}' /proc/meminfo)
402 403 404 405
	# use 2 * avaiable ram or no more than 1/3 of smallest disk space
	local size=$(( $memtotal_kb * 2 / 1024 ))
	local disk= disksize=
	for disk in $@; do
406 407
		local sysfsdev=$(echo ${disk#/dev/} | sed 's:/:!:g')
		local sysfspath=/sys/block/$sysfsdev/size
408 409 410 411 412 413 414 415 416 417 418 419 420 421 422
		# disksize = x * 512 / (1024 * 1024) = x / 2048
		# maxsize = $disksize / 4 = x / (2048 * 4) = x / 8192
		maxsize=$(awk '{ printf "%i", $0 / 8192 }' $sysfspath )
		if [ $size -gt $maxsize ]; then
			size=$maxsize
		fi
	done
	if [ $size -gt 4096 ]; then
		# dont ever use more than 4G
		size=4096
	elif [ $size -lt 64 ]; then
		# dont bother create swap smaller than 64MB
		size=0
	fi
	echo $size
423 424 425 426
}

has_mounted_part() {
	local p
427
	local sysfsdev=$(echo ${1#/dev/} | sed 's:/:!:g')
Natanael Copa's avatar
Natanael Copa committed
428
	# parse /proc/mounts for mounted devices
429
	for p in $(awk '$1 ~ /^\/dev\// {gsub("/dev/", "", $1); gsub("/", "!", $1); print $1}' \
430
			/proc/mounts); do
431 432
		[ "$p" = "$sysfsdev" ] && return 0
		[ -e /sys/block/$sysfsdev/$p ] && return 0
433 434 435 436
	done
	return 1
}

Natanael Copa's avatar
Natanael Copa committed
437 438 439 440 441 442 443 444 445 446 447 448 449 450 451
has_holders() {
	local i
	# check if device is used by any md devices
	for i in $1/holders/* $1/*/holders/*; do
		[ -e "$i" ] && return 0
	done
	return 1
}

is_available_disk() {
	local dev=$1
	local b=$(echo $p | sed 's:/:!:g')

	# check if its a "root" block device and not a partition
	[ -e /sys/block/$b ] || return 1
452

Natanael Copa's avatar
Natanael Copa committed
453 454 455 456
	# check so it does not have mounted partitions
	has_mounted_part $dev && return 1

	# check so its not part of an md setup
457 458 459 460
	if has_holders /sys/block/$b; then
		[ -n "$USE_RAID" ] && echo "Warning: $dev is part of a running raid" >&2
		return 1
	fi
Natanael Copa's avatar
Natanael Copa committed
461 462 463 464 465 466 467

	# check so its not an md device
	[ -e /sys/block/$b/md ] && return 1

	return 0
}

468
find_disks() {
Natanael Copa's avatar
Natanael Copa committed
469
	local p=
470 471
	# filter out ramdisks (major=1)
	for p in $(awk '$1 != 1 && $1 ~ /[0-9]+/ {print $4}' /proc/partitions); do
Natanael Copa's avatar
Natanael Copa committed
472
		is_available_disk $p && echo -n " $p"
473 474 475
	done
}

476 477 478 479 480 481 482 483 484
stop_all_raid() {
	local rd
	for rd in /dev/md*; do
		[ -b $rd ] && mdadm --stop $rd
	done
}

# install needed programs
init_progs() {
485
	local raidpkg= lvmpkg= fs= fstools=
486
	[ -n "$USE_RAID" ] && raidpkg="mdadm"
487
	[ -n "$USE_LVM" ] && lvmpkg="lvm2"
488 489 490
	for fs in $BOOTFS $ROOTFS $VARFS; do
		# we need load btrfs module early to avoid the error message:
		# 'failed to open /dev/btrfs-control'
491 492 493
		if ! grep -q -w "$fs" /proc/filesystems; then
			modprobe $fs
		fi
494 495 496 497 498

		case $fs in
		xfs) fstools="$fstools xfsprogs";;
		ext*) fstools="$fstools e2fsprogs";;
		btrfs) fstools="$fstools btrfs-progs";;
499 500
		esac
	done
501
	apk add --quiet sfdisk $lvmpkg $raidpkg $fstools $@
502 503
}

504
show_disk_info() {
Natanael Copa's avatar
Natanael Copa committed
505
	local disk= vendor= model= d= size=
506
	for disk in $@; do
507 508
		local dev=${disk#/dev/}
		d=$(echo $dev | sed 's:/:!:g')
509 510 511
		vendor=$(cat /sys/block/$d/device/vendor 2>/dev/null)
		model=$(cat /sys/block/$d/device/model 2>/dev/null)
		size=$(awk '{gb = ($1 * 512)/1000000000; printf "%.1f GB\n", gb}' /sys/block/$d/size 2>/dev/null)
512
		echo "  $dev	($size $vendor $model)"
513 514
	done
}
515

516 517
confirm_erase() {
	local answer=
518 519
	local erasedisks="$@"
	if [ "$ERASE_DISKS" = "$erasedisks" ]; then
Natanael Copa's avatar
Natanael Copa committed
520
		return 0
521
	fi
522
	echo "WARNING: The following disk(s) will be erased:"
523
	show_disk_info $@
524
	echo -n "WARNING: Erase the above disk(s) and continue? [y/N]: "
525

526 527
	read answer
	case "$answer" in
528
		y*|Y*) return 0;;
529
	esac
530
	return 1
531 532
}

533
# setup partitions on given disk dev in $1.
534
# usage: setup_partitions <diskdev> size1,type1 [size2,type2 ...]
535 536 537 538 539
setup_partitions() {
	local diskdev="$1"
	shift

	echo "Initializing partitions on $diskdev..."
540 541 542 543 544 545 546

	# new disks does not have an DOS signature in sector 0
	# this makes sfdisk complain. We can workaround this by letting
	# fdisk create that DOS signature, by just do a "w", a write.
	# http://bugs.alpinelinux.org/issues/show/145
	echo "w" | fdisk $diskdev >/dev/null

547
	# fix the MBR while here so extlinux can boot
548 549 550
	if [ -f "$MBR" ]; then
		cat "$MBR" > $diskdev
	fi
551

552
	local start=1M
553
	local line=
554 555
	# create new partitions
	(
556 557 558 559
		for line in "$@"; do
			echo "$start,$line"
			start=
		done
560
	) | sfdisk --quiet $diskdev >/dev/null || return 1
561 562 563 564 565 566 567 568 569 570

	# create device nodes if not exist
	mdev -s
}

# find the bootable partition on given disk
find_boot_partition() {
	sfdisk -d $1 | awk '/bootable/ {print $1}'
}

571 572 573 574 575
# find partition from PReP type on given disk
find_prep_partition() {
	sfdisk -d $1 | awk '/type=41/ {print $1}'
}

576
# find the partition(s) for LVM
577
# this is not marked as bootable and is type 8e
578 579
find_lvm_partition() {
	local type=8e
580
	sfdisk -d $1 | grep -v bootable | awk "/(Id|type)=$type/ {print \$1}"
581 582
}

583
# set up optional raid and create filesystem on boot device.
584
setup_boot_dev() {
585 586
	local disks="$@" disk= bootdev= mkfs_args="-q"
	local part=$(for disk in $disks; do find_boot_partition $disk; done)
587 588
	set -- $part
	bootdev=$1
589
	[ -z "$bootdev" ] && return 1
590 591 592 593 594 595 596 597 598 599

	if [ "$ARCH" = "ppc64le" ]; then
		# Change bootable partition to PReP partition
		for disk in $disks; do
			echo ',,,*' | sfdisk --quiet $disk -N1
			echo ',,,-' | sfdisk --quiet $disk -N2
			mdev -s
		done
	fi

600
	echo "Creating file systems..."
601
	if [ -n "$USE_RAID" ]; then
602 603 604 605 606 607
		local missing=
		local num=$#
		if [ $# -eq 1 ]; then
			missing="missing"
			num=2
		fi
608
		# we only use raid level 1 for boot devices
609 610
		mdadm --create /dev/md0 --level=1 --raid-devices=$num \
			--metadata=0.90 --quiet --run $@ $missing || return 1
611 612
		bootdev=/dev/md0
	fi
613 614 615 616
	case "$BOOTFS" in
	btrfs) mkfs_args="";;
	ext4) mkfs_args="$mkfs_args -O ^64bit";; # pv-grub does not support 64bit
	esac
617
	mkfs.$BOOTFS $MKFS_OPTS_BOOT $mkfs_args $bootdev
618 619 620 621
	BOOT_DEV="$bootdev"
}

# $1 = index
622 623 624
# $2 = partition type
# $3... = disk devices
find_nth_non_boot_parts() {
625
	local idx=$1
626
	local id=$2
627 628
	local disk=
	shift
629
	shift
630 631
	for disk in $@; do
		sfdisk -d $disk | grep -v bootable \
632
			| awk "/(Id|type)=$id/ { i++; if (i==$idx) print \$1 }"
633 634 635 636 637 638
	done
}

setup_non_boot_raid_dev() {
	local md_dev=$1
	local idx=${md_dev#/dev/md}
639 640 641 642 643
	if [ "$ARCH" = "ppc64le" ]; then
		# increment idx as PReP partition is
		# the bootable partition in ppc64le
		idx=$((idx+1))
	fi
644 645 646
	shift
	local level=1
	local missing=
647
	local raid_parts=$(find_nth_non_boot_parts $idx "fd" $@)
648 649 650 651 652 653 654 655
	set -- $raid_parts
	# how many disks do we have?
	case $# in
		0) echo "No Raid partitions found" >&2; return 1;;
		1) level=1; missing="missing"; num=2;;
		2) level=1; missing=  ; num=2;;
		*) level=5; missing=  ; num=$#;;
	esac
656
	mdadm --create $md_dev --level=$level --raid-devices=$num \
657
		--quiet --run $@ $missing || return 1
658 659 660 661
}

# setup device for lvm, create raid array if needed
setup_lvm_volume_group() {
662 663 664
	local vgname="$1"
	shift
	local lvmdev=
665 666

	if [ -n "$USE_RAID" ]; then
667 668
		setup_non_boot_raid_dev /dev/md1 $@ || return 1
		lvmdev=/dev/md1
669
	else
670
		lvmdev=$(find_lvm_partition $1)
671 672 673 674 675
	fi

	# be quiet on success
	local errmsg=$(dd if=/dev/zero of=$lvmdev bs=1k count=1 2>&1) \
		|| echo "$errmsg"
676 677 678 679 680 681 682 683 684 685 686 687
	pvcreate --quiet $lvmdev \
		&& vgcreate --quiet $vgname $lvmdev >/dev/null
}

# set up swap on given device(s)
setup_swap_dev() {
	local swap_dev=
	sed -i -e '/swap/d' /etc/fstab
	for swap_dev in "$@"; do
		mkswap $swap_dev >/dev/null
		echo -e "$swap_dev\tswap\t\tswap\tdefaults 0 0" >> /etc/fstab
	done
688
	SWAP_DEVICE="$(uuid_or_device $swap_dev)"
689 690
	swapon -a
	rc-update --quiet add swap boot
691 692 693
}

# setup and enable swap on given volumegroup if needed
694
setup_lvm_swap() {
695
	local vgname="$1"
696
	local swapname=lv_swap
697 698 699
	if [ -z "$SWAP_SIZE" ] || [ "$SWAP_SIZE" -eq 0 ]; then
		return
	fi
700 701
	lvcreate --quiet -n $swapname -L ${SWAP_SIZE}MB $vgname
	setup_swap_dev /dev/$vgname/$swapname
702 703 704 705 706 707 708 709 710 711
}

# if /var is mounted, move out data and umount it
reset_var() {
	[ -z "$(find_mount_dev /var)" ] && return 0
	mkdir /.var
	mv /var/* /.var/ 2>/dev/null
	umount /var && 	rm -rf /var && mv /.var /var && rm -rf /var/lost+found
}

712 713 714
# set up /var on given device
setup_var() {
	local var_dev="$1"
715
	local varfs=${VARFS}
716
	echo "Creating file systems..."
717
	mkfs.$varfs $MKFS_OPTS_VAR $var_dev >/dev/null || return 1
718 719 720 721 722 723 724 725 726
	sed -i -e '/[[:space:]]\/var[[:space:]]/d' /etc/fstab
	echo -e "${var_dev}\t/var\t\t${varfs}\tdefaults 1 2" >> /etc/fstab

	mv /var /.var
	mkdir /var
	mount /var
	mv /.var/* /var/
	rmdir /.var

727
	service syslog --quiet condrestart
728
	setup_mdadm_conf
729 730
}

731
setup_mdadm_conf() {
732
	local mods= mod=
733 734 735
	if [ -n "$USE_RAID" ]; then
		mdadm --detail --scan > /etc/mdadm.conf
		rc-update --quiet add mdadm-raid boot
736 737 738 739 740 741
		mods=$(awk '/^raid/ {print $1}' /proc/modules)
		for mod in $mods; do
			if ! grep -q "^$mod" /etc/modules; then
				echo $mod >> /etc/modules
			fi
		done
742 743 744
	fi
}

745
data_only_disk_install_lvm() {
746
	local diskdev=
747 748
	local vgname=vg0
	local var_dev=/dev/$vgname/lv_var
749 750 751
	local lvm_part_type="8e"
	local part_type=$lvm_part_type
	local size=
752 753

	init_progs || return 1
754
	confirm_erase $@ || return 1
755

756
	if [ "$USE_RAID" ]; then
757 758
		# the paritition type for raid is "fd"
		part_type="fd"
759 760
		stop_all_raid
	fi
761

762
	for diskdev in "$@"; do
763
		setup_partitions $diskdev "${size}${size:+M},$part_type" || return 1
764
	done
765

766 767
	setup_lvm_volume_group $vgname $@ || return 1
	setup_lvm_swap $vgname
768
	lvcreate --quiet -n ${var_dev##*/} -l 100%FREE $vgname
769
	setup_mdadm_conf
Natanael Copa's avatar
Natanael Copa committed
770
	rc-update add lvm boot
771
	setup_var $var_dev
772 773
}

774 775
data_only_disk_install() {
	local diskdev=
776 777
	local var_dev=
	local var_part_type="83"
778 779 780 781 782 783 784 785 786 787 788 789 790 791 792
	local swap_part_type=82
	local size=
	local swap_dev= var_dev=

	init_progs || return 1
	confirm_erase $@ || return 1

	if [ "$USE_RAID" ]; then
		var_part_type="fd"
		swap_part_type="fd"
		stop_all_raid
	fi

	for diskdev in "$@"; do
		setup_partitions $diskdev \
793 794
			"${SWAP_SIZE}M,$swap_part_type" \
			"${size}${size:+M},$var_part_type" || return 1
795 796 797 798 799 800 801 802 803 804 805 806 807 808 809
	done

	if [ "$USE_RAID" ]; then
		[ $SWAP_SIZE -gt 0 ] && setup_non_boot_raid_dev /dev/md1 $@
		setup_non_boot_raid_dev /dev/md2 $@ || return 1
		swap_dev=/dev/md1
		var_dev=/dev/md2
	else
		swap_dev=$(find_nth_non_boot_parts 1 82 $@)
		var_dev=$(find_nth_non_boot_parts 1 83 $@)
	fi
	[ $SWAP_SIZE -gt 0 ] && setup_swap_dev $swap_dev
	setup_var $var_dev
}

810
# setup
811
setup_root() {
812 813 814
	local root_dev="$1" boot_dev="$2"
	shift 2
	local disks="$@" mkfs_args="-q"
Natanael Copa's avatar
Natanael Copa committed
815
	[ "$ROOTFS" = "btrfs" ] && mkfs_args=""
816
	mkfs.$ROOTFS $MKFS_OPTS_ROOT $mkfs_args "$root_dev"
817 818
	mkdir -p "$SYSROOT"
	mount -t $ROOTFS $root_dev "$SYSROOT" || return 1
819
	if [ -n "$boot_dev" ]; then
820 821
		mkdir -p "$SYSROOT"/boot
		mount -t $BOOTFS $boot_dev "$SYSROOT"/boot || return 1
822 823 824
	fi

	setup_mdadm_conf
825
	install_mounted_root "$SYSROOT" "$disks" || return 1
826
	unmount_partitions "$SYSROOT"
827 828 829
	swapoff -a

	echo ""
830
	echo "Installation is complete. Please reboot."
831 832
}

833
native_disk_install_lvm() {
834 835 836 837 838 839 840
	local diskdev= vgname=vg0
	local lvm_part_type="8e"
	local boot_part_type="83"
	local boot_size=${BOOT_SIZE:-100}
	local lvm_size=
	local root_dev=/dev/$vgname/lv_root

841
	init_progs syslinux || return 1
842
	confirm_erase $@ || return 1
843 844

	if [ -n "$USE_RAID" ]; then
845 846 847
		boot_part_type="fd"
		lvm_part_type="fd"
		stop_all_raid
848
	fi
849 850
	for diskdev in "$@"; do
		setup_partitions $diskdev \
851 852
			"${boot_size}M,$boot_part_type,*" \
			"${lvm_size}${lvm_size:+M},$lvm_part_type" || return 1
853 854 855 856 857 858 859 860
	done

	# will find BOOT_DEV for us
	setup_boot_dev $@

	setup_lvm_volume_group $vgname $@ || return 1
	setup_lvm_swap $vgname
	lvcreate --quiet -n ${root_dev##*/} -l 100%FREE $vgname
Natanael Copa's avatar
Natanael Copa committed
861
	rc-update add lvm boot
862
	setup_root $root_dev $BOOT_DEV
Natanael Copa's avatar
Natanael Copa committed
863 864
}

865
native_disk_install() {
866 867
	local prep_part_type="41" root_part_type="83" swap_part_type="82" boot_part_type="83"
	local prep_size=8
868 869 870 871
	local boot_size=${BOOT_SIZE:-100}
	local swap_size=${SWAP_SIZE}
	local root_size=
	local root_dev= boot_dev= swap_dev=
872
	local bootloader=
873

874 875 876 877 878
	case "$ARCH" in
		ppc64le) bootloader=grub-ieee1275;;
		*) bootloader=syslinux;;
	esac
	init_progs $bootloader || return 1
879 880 881 882 883 884 885 886 887
	confirm_erase $@ || return 1

	if [ -n "$USE_RAID" ]; then
		boot_part_type="fd"
		root_part_type="fd"
		swap_part_type="fd"
		stop_all_raid
	fi
	for diskdev in "$@"; do
888 889 890 891 892 893 894 895 896 897 898 899 900 901 902
		if [ "$ARCH" = "ppc64le" ]; then
			setup_partitions $diskdev \
				"${prep_size}M,$prep_part_type" \
				"${boot_size}M,$boot_part_type,*" \
				"${swap_size}M,$swap_part_type" \
				"${root_size}${root_size:+M},$root_part_type" \
				|| return 1

		else
			setup_partitions $diskdev \
				"${boot_size}M,$boot_part_type,*" \
				"${swap_size}M,$swap_part_type" \
				"${root_size}${root_size:+M},$root_part_type" \
				|| return 1
		fi
903 904 905 906
	done

	# will find BOOT_DEV for us
	setup_boot_dev $@
907

908 909 910 911 912 913 914
	if [ "$USE_RAID" ]; then
		[ $SWAP_SIZE -gt 0 ] && setup_non_boot_raid_dev /dev/md1 $@
		setup_non_boot_raid_dev /dev/md2 $@ || return 1
		swap_dev=/dev/md1
		root_dev=/dev/md2
	else
		swap_dev=$(find_nth_non_boot_parts 1 82 $@)
915 916 917 918 919 920 921 922
		local index=
		case "$ARCH" in
			# use the second non botable partition on ppc64le,
			# as PReP partition is the bootable partition
			ppc64le) index=2;;
			*) index=1;;
		esac
		root_dev=$(find_nth_non_boot_parts $index 83 $@)
923
	fi
924

925
	[ $SWAP_SIZE -gt 0 ] && setup_swap_dev $swap_dev
926
	setup_root $root_dev $BOOT_DEV $@
927 928
}

929
diskselect_help() {
930
	cat <<-__EOF__
931

932 933
		The disk you select can be used for a traditional disk install or for a
		data-only install.
934

935
		The disk will be erased.
936

937
		Enter 'none' if you want to run diskless.
938

939
	__EOF__
940 941
}

942
diskmode_help() {
943
	cat <<-__EOF__
944

945
		You can select between 'sys', 'data', 'lvm', 'lvmsys' or 'lvmdata'.
946

947 948 949
		sys:
		  This mode is a traditional disk install. The following partitions will be
		  created on the disk: /boot, / (filesystem root) and swap.
950

951
		  This mode may be used for development boxes, desktops, virtual servers, etc.
952

953 954 955
		data:
		  This mode uses your disk(s) for data storage, not for the operating system.
		  The system itself will run from tmpfs (RAM).
956

957 958
		  Use this mode if you only want to use the disk(s) for a mailspool, databases,
		  logs, etc.
959

960 961
		lvm:
		  Enable logical volume manager and ask again for 'sys' or 'data'.
962

963 964
		lvmsys:
		  Same as 'sys' but use logical volume manager for partitioning.
965

966 967
		lvmdata:
		  Same as 'data' but use logical volume manager for partitioning.
968

969
	__EOF__
970 971 972 973 974 975 976
}

# ask for a root or data disk
# returns answer in global variable $answer
ask_disk() {
	local prompt="$1"
	local help_func="$2"
977
	local i=
978 979
	shift 2
	answer=
980
	local default_disk=${DEFAULT_DISK:-$1}
981

982 983 984
	while ! all_in_list "$answer" $@ "none" "abort"; do
		echo "Available disks are:"
		show_disk_info "$@"
985 986
		echon "$prompt [$default_disk] "
		default_read answer $default_disk
987 988 989 990
		case "$answer" in
			'abort') exit 0;;
			'none') return 0;;
			'?') $help_func;;
991 992 993 994
			*) for i in $answer; do
				if ! [ -b "/dev/$i" ]; then
					echo "/dev/$i is not a block device" >&2
					answer=
995
				fi
996
			done;;
997 998 999 1000
		esac
	done
}

1001
usage() {
1002 1003 1004 1005 1006 1007 1008 1009 1010 1011 1012 1013 1014 1015 1016 1017 1018 1019 1020 1021 1022 1023 1024 1025 1026 1027 1028
	cat <<-__EOF__
		usage: setup-disk [-hLqrv] [-k kernelflavor] [-m MODE] [-o apkovl] [-s SWAPSIZE]
		                  [MOUNTPOINT | DISKDEV...]

		Install alpine on harddisk.

		If MOUNTPOINT is specified, then do a traditional disk install with MOUNTPOINT
		as root.

		If DISKDEV is specified, then use the specified disk(s) without asking. If
		multiple disks are specified then set them up in a RAID array. If there are
		mode than 2 disks, then use raid level 5 instead of raid level 1.

		options:
		 -h  Show this help
		 -m  Use disk for MODE without asking, where MODE is either 'data' or 'sys'
		 -o  Restore system from given apkovl file
		 -k  Use kernelflavor instead of $KERNEL_FLAVOR
		 -L  Use LVM to manage partitions
		 -q  Exit quietly if no disks are found
		 -r  Enable software raid1 with single disk
		 -s  Use SWAPSIZE MB instead of autodetecting swap size (Use 0 to disable swap)
		 -v  Be more verbose about what is happening

		If BOOTFS, ROOTFS, VARFS are specified, then format a partition with specified
		filesystem. If not specified, the default filesystem is ext4.
		Supported filesystems for
1029
		  boot: ext2, ext3, ext4, btrfs, xfs
1030 1031 1032
		  root: ext2, ext3, ext4, btrfs, xfs
		   var: ext2, ext3, ext4, btrfs, xfs
	__EOF__
1033 1034 1035
	exit 1
}

Francesco Colista's avatar
Francesco Colista committed
1036 1037
kver=$(uname -r)
case $kver in
1038 1039 1040
	*-rc[0-9]*) KERNEL_FLAVOR=vanilla;;
	*-[a-z]*) KERNEL_FLAVOR=${kver##*-};;
	*) KERNEL_FLAVOR=vanilla;;
1041 1042
esac

1043
DISK_MODE=
1044
USE_LVM=
1045
# Parse args
1046
while getopts "hk:Lm:o:qrs:v" opt; do
1047
	case $opt in
1048
		m) DISK_MODE="$OPTARG";;
1049
		k) KERNEL_FLAVOR="$OPTARG";;
1050
		L) USE_LVM="_lvm";;
1051
		o) APKOVL="$OPTARG";;
1052 1053
		q) QUIET=1;;
		r) USE_RAID=1;;
1054
		s) SWAP_SIZE="$OPTARG";;
1055
		v) VERBOSE=1;;
Natanael Copa's avatar
Natanael Copa committed
1056
		*) usage;;
1057 1058
	esac
done
1059
shift $(( $OPTIND - 1))
1060

1061 1062
if [ -d "$1" ]; then
	# install to given mounted root
1063
	apk add --quiet syslinux
1064 1065
	install_mounted_root "${1%/}" \
		&& echo "You might need fix the MBR to be able to boot" >&2
1066 1067 1068
	exit $?
fi

1069 1070 1071 1072 1073 1074 1075 1076 1077 1078
reset_var
swapoff -a

# stop all volume groups in use
vgchange --ignorelockingfailure -a n >/dev/null 2>&1

if [ -n "$USE_RAID" ]; then
	stop_all_raid
fi

1079
disks=$(find_disks)
1080
diskdevs=
Natanael Copa's avatar
Natanael Copa committed
1081 1082

# no disks so lets exit quietly.
1083 1084 1085 1086
if [ -z "$disks" ]; then
	[ -z "$QUIET" ] && echo "No disks found." >&2
	exit 0
fi
Natanael Copa's avatar
Natanael Copa committed
1087

1088
if [ $# -gt 0 ]; then
1089
	# check that they are
1090 1091 1092
	for i in "$@"; do
		j=$(readlink -f "$i" | sed 's:^/dev/::; s:/:!:g')
		if ! [ -e "/sys/block/$j/device" ]; then
1093
			echo "$i is not a suitable for partitioning"
1094 1095
			exit 1
		fi
1096
		diskdevs="$diskdevs /dev/${j//!//}"
1097 1098
	done
else
1099
	ask_disk "Which disk(s) would you like to use? (or '?' for help or 'none')" \
1100
		diskselect_help $disks
1101
	if [ "$answer" != none ]; then
1102 1103 1104
		for i in $answer; do
			diskdevs="$diskdevs /dev/$i"
		done
1105 1106
	else
		DISK_MODE="none"
1107
	fi
1108
fi
Natanael Copa's avatar
Natanael Copa committed
1109

1110
if [ -n "$diskdevs" ] && [ -z "$DISK_MODE" ]; then
1111
	answer=
1112
	disk_is_or_disks_are="disk is"
1113
	it_them="it"
1114
	set -- $diskdevs
1115
	if [ $# -gt 1 ]; then
1116
		disk_is_or_disks_are="disks are"
1117 1118
		it_them="them"
	fi
1119

1120
	while true; do
1121
		echo "The following $disk_is_or_disks_are selected${USE_LVM:+ (with LVM)}:"
1122
		show_disk_info $diskdevs
1123
		_lvm=${USE_LVM:-", 'lvm'"}
1124
		echon "How would you like to use $it_them? ('sys', 'data'${_lvm#_lvm} or '?' for help) [?] "
1125 1126 1127
		default_read answer '?'
		case "$answer" in
		'?') diskmode_help;;
1128
		sys|data) break;;
1129 1130 1131 1132 1133 1134 1135
		lvm) USE_LVM="_lvm" ;;
		nolvm) USE_LVM="";;
		lvmsys|lvmdata)
			answer=${answer#lvm}
			USE_LVM="_lvm"
			break
			;;
1136 1137
		esac
	done
1138
	DISK_MODE="$answer"
1139
fi
Natanael Copa's avatar
Natanael Copa committed
1140

1141 1142 1143 1144
if [ -z "$SWAP_SIZE" ]; then
	SWAP_SIZE=$(find_swap_size $diskdevs)
fi

1145 1146 1147 1148
set -- $diskdevs
if [ $# -gt 1 ]; then
	USE_RAID=1
fi
1149

1150 1151
dmesg -n1

1152
# native disk install
1153
case "$DISK_MODE" in
1154
sys) native_disk_install$USE_LVM $diskdevs;;
1155
data) data_only_disk_install$USE_LVM $diskdevs;;
1156
none) exit 0;;
1157
*) echo "Not a valid install mode: $DISK_MODE" >&2; exit 1;;
1158
esac
Natanael Copa's avatar
Natanael Copa committed
1159

1160
RC=$?
1161
echo "$DISK_MODE" > /tmp/alpine-install-diskmode.out
1162
exit $RC